﻿//访问后台接口
//var baseUrl = "http://192.168.1.50:814/";
var baseUrl = "http://116.62.222.219:8093/";
//获取接口
var apiUrl = {
    //获取Token
    "getToken": baseUrl + "api/Common/PostSearchToken",
    //获取登录
    "postLogin": baseUrl + "api/Login/LoginLogistics",
    //获取待确认 配送中 已完成数量
    "getCountByUserId": baseUrl + "api/ExpressesTask/PostSearchCountByUserId",
    //获取配货任务列表
    "getTaskListByUserId": baseUrl + "api/ExpressesTask/PostSearchByUserId",
    //忘记密码的验证码
    "getSendValidateCode": baseUrl + "api/UserInfo/PostSendValidateCode",
    //忘记密码中输入验证码后设置新密码
    "getSetNewPassword": baseUrl + "api/ExpressUser/PostSetNewPassword",
    //任务列表点击"完成配货"的接口
    "getEditBuyCount": baseUrl + "api/Orders/PostEditBuyCount",
    //配送任务的列表详情
    "getSearchSendByUserId": baseUrl + "/api/ExpressesTask/PostSearchSendByUserId",
    //配送详情的点击“完成配送”接口
    "getFinshedExpressesTask": baseUrl + "api/ExpressesTask/PostFinshedExpressesTask",
    //修改密码
    "getEditNewPassword": baseUrl + "api/ExpressUser/PostEditUserPassword",
    //查询配送已完成记录
    "getSearchFinshedByUserId": baseUrl + "api/ExpressesTask/PostSearchFinshedByUserId",
    //查询待接单订单记录
    "getWait": baseUrl + "api/Orders/PostSearchWaitReceiveOrder",
    //骑手接单
    "receive": baseUrl + "api/Orders/PostReceivedOrder"
};
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'ngCookies', 'ngResource'])

.run(function ($ionicPlatform) {
    $ionicPlatform.ready(function () {
        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            cordova.plugins.Keyboard.disableScroll(true);
        }
        if (window.StatusBar) {
            StatusBar.styleDefault();
        }
    });
})

.config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $httpProvider) {
    $httpProvider.defaults.useXDomain = true;
    $httpProvider.defaults.withCredentials = false;
    delete $httpProvider.defaults.headers.common['X-Requested-With'];
    $httpProvider.defaults.headers.put['Content-Type'] = 'application/x-www-form-urlencodedv;charset=utf-8';
    $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
    $httpProvider.defaults.transformRequest = [function (data) {
        /**
         * The workhorse; converts an object to x-www-form-urlencoded serialization.
         * @param {Object} obj
         * @return {String}
         */
        var param = function (obj) {
            var save = '';
            var name, value, fullSubName, subName, subValue, innerObj, i;

            for (name in obj) {
                value = obj[name];

                if (value instanceof Array) {
                    for (i = 0; i < value.length; ++i) {
                        subValue = value[i];
                        fullSubName = name + '[' + i + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        save += param(innerObj) + '&';
                    }
                } else if (value instanceof Object) {
                    for (subName in value) {
                        subValue = value[subName];
                        fullSubName = name + '[' + subName + ']';
                        innerObj = {};
                        innerObj[fullSubName] = subValue;
                        save += param(innerObj) + '&';
                    }
                } else if (value !== undefined && value !== null) {
                    save += encodeURIComponent(name) + '='
                            + encodeURIComponent(value) + '&';
                }
            }

            return save.length ? save.substr(0, save.length - 1) : save;
        };

        return angular.isObject(data) && String(data) !== '[object File]'
                ? param(data)
                : data;
    }];

    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('bottom');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');
    $stateProvider
      .state('tab', {
          url: '/tab',
          abstract: true,
          templateUrl: 'templates/tabs.html',
          controller: 'tabCtrl'
      })
    
    .state('tab.center', {
        cache: false,
        url: '/center',
        views: {
            'tab-center': {
                templateUrl: 'templates/tab-center.html',
                controller: 'centerCtrl'
            }
        }
    })

    .state('waitList', {
        cache: false,
        url: '/waitList',
        templateUrl: 'templates/tab-waitList.html',
        controller: 'waitListCtrl'
    })

    .state('tab.task', {
        cache: false,
        url: '/task',
        views: {
            'tab-task': {
                templateUrl: 'templates/tab-task.html',
                controller: 'taskCtrl'
            }
        }
    })

     .state('tab.history', {
         cache: false,
         url: '/history',
         views: {
             'tab-history': {
                 templateUrl: 'templates/tab-history.html',
                 controller: 'historyCtrl'
             }
         }
     })

      .state('tab.delivery', {
          cache: false,
          url: '/delivery',
          views: {
              "tab-delivery": {
                  templateUrl: 'templates/tab-delivery.html',
                  controller: 'deliveryCtrl'
              }
          }
      })

     .state('login', {
         cache: false,
         url: '/login',
         templateUrl: 'templates/login.html',
         controller: 'loginCtrl'
     })

     .state('center', {
        cache: false,
        url: '/center',
        templateUrl: 'templates/tabs.html',
        controller: 'centerCtrl'
    })

     .state('tab.changePassword', {
         cache: false,
         url: '/changePassword',
         views: {
             "tab-center": {
                 templateUrl: 'templates/changePassword.html',
                 controller: 'changePasswordCtrl'
             }
         }
     })

    .state('forgetPassword', {
        cache: false,
        url: '/forgetPassword',
        templateUrl: 'templates/forgetPassword.html',
        controller: 'forgetPasswordCtrl'
    });
    $urlRouterProvider.otherwise('/tab/center');

})
    //滚动
  .config(function ($anchorScrollProvider) {

  })

.config(["$resourceProvider", function ($resourceProvider) {

    var transformResponse = function (data) {
        return angular.fromJson(angular.fromJson(data));
    };

    //important：拦截器
    var interceptor = {
        response: function (res) {
            var returnData = res.data;
            switch (returnData.status) {
                case "success":
                    return returnData;
                    break;
                case "timeout":
                    location.href = "#login"
                    break;
                case "error":
                //$ionicLoading.show({ template: "系统错误.", noBackdrop: true, duration: 2000 });
                    alert("系统错误");
                    break;
                case "tokenerror":
                //$ionicLoading.show({ template: "系统错误.", noBackdrop: true, duration: 2000 });
                    alert("系统错误");
                    break;
                case "viewerror":
                //$ionicLoading.show({ template: "系统错误.", noBackdrop: true, duration: 2000 });
                    alert("系统错误");
                    break;
                case "operationerror":
                    break;
                case "fmapierror":
                    break;
                case "parametererror":
                alert("系统错误");
                //$ionicLoading.show({ template: "参数错误.", noBackdrop: true, duration: 2000 });
                    break;
                default:
                return returnData;
                //$ionicLoading.show({ template:returnData.message, noBackdrop: true, duration: 2000 });
                    break;
            }
        },
        responseError: function (err) {
            console.log(err);
        }
    };


    $resourceProvider.defaults.actions.get = {
        transformResponse: transformResponse,
        interceptor: interceptor
    };


    $resourceProvider.defaults.actions.save = {
        method: "POST",
        transformResponse: transformResponse,
        interceptor: interceptor
    };

    return $resourceProvider;


}])


