﻿angular.module('starter.controllers', ["ngCookies"])
.controller('tabCtrl', ["$scope", "$rootScope", "$state", function ($scope, $rootScope, $state) {
    //$ionicView.beforeEnter页面刚加载
    $rootScope.$on('$ionicView.beforeEnter', function () {
        var stateName = $state.current.name;
        //除state名为tab.task和tab.center的页面外，其他页面的底部导航栏隐藏
        // if (stateName === 'tab.task' || stateName === 'tab.center' || stateName === 'tab.historicalrecord') {
        //     $rootScope.hideTabs = false;
        // } else {
        //     $rootScope.hideTabs = true;
        // }
    });
}])

//新订单/骑手接单
.controller('waitListCtrl', ["$scope", "WaitListService", "$state", "$ionicPopup", "$ionicLoading", function ($scope, waitListService, $state, $ionicPopup, $ionicLoading) {
    
    if (localStorage.haslogin != 1) {
        $state.go("login");
    }
    
    $scope.waitLoad = false;
    waitListService.all(function (data) {
        if (data.status === "success") {
            $scope.waitLoad = true;
            if (data.result.orderList.length != 0 && data != null) {
                $scope.waitList = data.result.orderList;
                document.getElementById("noWait").style.display = "none";
                document.getElementById("waitContent").style.display = "block";
            } else {
                document.getElementById("noWait").style.display = "block";
                document.getElementById("waitContent").style.display = "none";
            }
        }
    });

    //点击确认按钮，完成接单
    var userId = localStorage.getItem("userId");
    $scope.receive = function (i,orderNum) {

        $scope.isBtn=false;
        $ionicLoading.show({
            content: '数据提交中...',
            animation: 'fade-in',
            showBackdrop: true,
            maxWidth: 200,
            showDelay: 0
          });

        waitListService.receive(function (data) {
            if (data.status === "success") {
                //隐藏加载层
                $ionicLoading.hide();
                if($scope.waitList.length==1)
                {
                    document.getElementById("noWait").style.display = "block";
                }
                $scope.waitList.splice(i,1);                            
                $ionicLoading.show({ template: "恭喜：接单成功,可以在待确认列表查看.", noBackdrop: true, duration:2000 });
            }
        },userId, orderNum);
    }
}])

.controller('taskCtrl', ["$scope", "TaskService", "$state", "$ionicPopup", "$ionicLoading", function ($scope, taskService, $state, $ionicPopup, $ionicLoading) {
    if (localStorage.haslogin != 1) {
        $state.go("login");
    }
    var userId = localStorage.getItem("userId");
    $scope.taskLoad = false;
    taskService.all(function (data) {

        if (data.status === "success") {
            $scope.taskLoad = true;
            if (data.result.taskList.length != 0 && data != null) {
                $scope.taskList = data.result.taskList;
                document.getElementById("noTask").style.display = "none";
                document.getElementById("taskContent").style.display = "block";
            } else {
                document.getElementById("noTask").style.display = "block";
                document.getElementById("taskContent").style.display = "none";
            }
        }
    }, userId);
    //点击确认按钮，完成订单明细确认
    $scope.orderSend = function (i, j) {
        var regExp = new RegExp(/^\d+(\.{0,1}\d{1})?$/);
        var isNum = true;
        for (var x = 0; x < $scope.taskList[i].orderList[j].orderDetail.length; x++) {
            var updateCount = $scope.taskList[i].orderList[j].orderDetail[x].count;
            if (!regExp.test(updateCount)) {
                isNum = false;
            }
        }
        if (!isNum) {
            $scope.taskList[i].orderList[j].isMatch = 1;
            $ionicLoading.show({ template: "数量请输入正整数或一位小数", noBackdrop: true, duration: 2000 });
        } else {
            var sendConfirm = $ionicPopup.confirm({
                template: '确定已完成明细确认？',
                noBackdrop: true,
                okText: '确定',
                okType: 'sure',
                cancelText: '取消',
                cancelType: 'cancel'
            });

           var loading = $ionicLoading.show({
                content: '数据提交中...',
                animation: 'fade-in',
                showBackdrop: true,
                maxWidth: 200,
                showDelay: 0
              });

            sendConfirm.then(function (res) {
                //隐藏按钮
                $scope.isBtn=false;

                $scope.countArray = [];
                $scope.orderNum = $scope.taskList[i].orderList[j].orderNum;
                $scope.taskList[i].orderList[j].orderDetail.map(function (item) {
                    $scope.countArray.push({
                        id: item.detailId,
                        value: item.count
                    });
                });
                if (res) {
                    taskService.eaitCount(function (data) {
                        $ionicLoading.hide();
                        if (data.status === "success") {
                            if($scope.taskList[i].orderList.length==1)
                            {
                                document.getElementById("taskContent").style.display = "none";
                                document.getElementById("noTask").style.display = "block";
                            }
                            $scope.taskList[i].orderList.splice(j,1);
                            $ionicLoading.show({ template: "该订单明细确认成功,进入配送环节.", noBackdrop: true, duration: 2000 });
                           
                        }
                        else{
                            $ionicLoading.show({ template: "该订单明细确认失败.", noBackdrop: true, duration: 2000 });
                        }
                    },userId, $scope.orderNum, JSON.stringify($scope.countArray));
                } else {     
                    $ionicLoading.show({ template: "该订单明细确认失败.", noBackdrop: true, duration: 2000 });
                }
            });
        }
    }
}])

.controller('deliveryCtrl', ["$scope", "DeliveryService", "$ionicPopup","$ionicLoading", "$state", function ($scope, deliveryService, $ionicPopup,$ionicLoading, $state) {

    if (localStorage.haslogin != 1) {
        $state.go("login");
    }
    var userId = localStorage.getItem("userId");
    $scope.deliveryLoad = false;
    deliveryService.all(function (data) {

        if (data && data.status === "success") {
            $scope.deliveryLoad = true;
            if (data.result.taskList.length != 0 && data != null) {
                $scope.deliveryList = data.result.taskList;
                document.getElementById("noDelivery").style.display = "none";
                document.getElementById("deliveryContent").style.display = "block";
            } else {
                document.getElementById("noDelivery").style.display = "block";
                document.getElementById("deliveryContent").style.display = "none";
            }
        }
    }, userId);
    //点击完成配送后，订单已经配送成功
    var btnNum = 0;
    $scope.deliveryFinish = function (i) {
        var deliveryConfirm = $ionicPopup.confirm({
            template: '确定已完成配送？',
            noBackdrop: true,
            okText: '确定',
            okType: 'sure',
            cancelText: '取消',
            cancelType: 'cancel'
        });
        deliveryConfirm.then(function (res) {
             //隐藏按钮
             $scope.isBtn=false;
             
            var orderNum = $scope.deliveryList[i].orderNum;
            var userId = localStorage.getItem("userId");
            if (res) {
                deliveryService.deliveryComplete(function (data) {
                    if (data.status === "success") {
                        if($scope.deliveryList.length==1)
                        {
                            document.getElementById("noDelivery").style.display = "block";
                        }
                        $scope.deliveryList.splice(i,1);
                        $ionicLoading.show({ template: "订单配送完成.", noBackdrop: true, duration: 2000 });
                    } else {
                        $ionicLoading.show({ template: data.message, noBackdrop: true, duration: 2000 });
                    }
                }, userId, orderNum);
            }
        });
    }
}])

.controller('changePasswordCtrl', ["$scope", "UpdatePasswordService", "$ionicLoading", "$state", "LoginService", function ($scope, updatePasswordService, $ionicLoading, $state, loginService) {
    var phone = localStorage.getItem("account");
    $scope.oldPassword = "";
    $scope.newPassword = "";
    $scope.confirmPassword = "";
    //提交修改的密码
    $scope.isSubmit = true;
    $scope.newPwdSubmit = function (oldPassword, newPassword, confirmPwd) {
        $scope.isSubmit = false;
        if (!oldPassword.length || oldPassword == "undefined") {
            $scope.isSubmit = true;
            $ionicLoading.show({ template: "请输入原始密码", noBackdrop: true, duration: 2000 });
        } else if (newPassword.length < 6 || newPassword.length > 15) {
            $scope.isSubmit = true;
            $ionicLoading.show({ template: "请输入6-15位新密码", noBackdrop: true, duration: 2000 });
        } else if (confirmPwd.length < 6 || confirmPwd.length > 15) {
            $scope.isSubmit = true;
            $ionicLoading.show({ template: "请输入6-15位确认密码", noBackdrop: true, duration: 2000 });
        } else if (confirmPwd == newPassword) {
            updatePasswordService.changePassword(function (data) {
                $scope.isSubmit = true;
                if (data.status == "success") {
                    loginService.setLocalUser(loginService.getLocalUser().phone, "");
                    localStorage.setItem("token", data.result.token);
                    $ionicLoading.show({ template: "密码修改成功.", noBackdrop: true, duration: 2000 });
                    window.history.back();//回到上一级页面
                } else {
                    $scope.isSubmit = true;
                    $ionicLoading.show({ template: data.message, noBackdrop: true, duration: 2000 });
                }
            }, phone, oldPassword, newPassword, "123456");
        } else {
            $scope.isSubmit = true;
            $ionicLoading.show({ template: "新密码与确认密码不一致.", noBackdrop: true, duration: 2000 });
        }
    }
}])

.controller('forgetPasswordCtrl', ["$scope", "ForgetPwdService", "$ionicLoading", "$state", function ($scope, forgetPwdService, $ionicLoading, $state) {
    $scope.user = {};
    $scope.user.phone = "";
    $scope.user.password = "";
    //获取验证码
    $scope.getValidatecode = function () {
        var phone = $scope.user.phone;
        if (phone == "") {
            $ionicLoading.show({ template: "请输入手机号码", noBackdrop: true, duration: 2000 });
        } else if (phone.length != 11) {
            $ionicLoading.show({ template: "请输入正确的手机号码", noBackdrop: true, duration: 2000 });
        } else {
            forgetPwdService.getValidateCode(function (data) {
                $scope.validateCode = data.result.validateCode;
                if (data.status === "success") {
                    $scope.sendTime = 30;
                    $scope.hasSend = true;
                    var updateTime = function () {
                        $scope.sendTime = $scope.sendTime - 1;
                        if ($scope.sendTime <= 0) {
                            $scope.hasSend = false;
                            clearInterval(stopTime);
                            return;
                        }
                    };
                    var stopTime = setInterval(function () {
                        $scope.$apply(updateTime);
                    }, 1000);
                } else {
                    $scope.user.phone = "";
                    $ionicLoading.show({ template: data.message, noBackdrop: true, duration: 1000 });
                }
            }, phone);
        }
    }
    //点击提交按钮，提交设置新密码的信息
    $scope.infoSubmit = function () {
        var password = $scope.user.password + "";
        var newPassword = $scope.user.newPassword + "";
        var validcode = $scope.user.validcode + "";
        if (!password.length || password == "undefined") {
            $ionicLoading.show({ template: '请输入新密码', noBackdrop: true, duration: 1000 });
        } else if (password.length > 15 || password.length < 6) {
            $ionicLoading.show({ template: '请输入6-15位新密码', noBackdrop: true, duration: 1000 });
        } else if (!newPassword.length || newPassword == "undefined") {
            $ionicLoading.show({ template: '请输入确认密码', noBackdrop: true, duration: 1000 });
        } else if (newPassword.length > 15 || newPassword.length < 6) {
            $ionicLoading.show({ template: '请输入6-15位确认密码', noBackdrop: true, duration: 1000 });
        } else if (password != newPassword) {
            $ionicLoading.show({ template: '两次密码输入不一致', noBackdrop: true, duration: 1000 });
        } else if (!validcode.length || validcode == "undefined") {
            $ionicLoading.show({ template: '请输入验证码', noBackdrop: true, duration: 1000 });
        } else if (validcode != $scope.validateCode) {
            $ionicLoading.show({ template: '验证码不正确', noBackdrop: true, duration: 1000 });
        } else {
            forgetPwd.setNewPassword(function (data) {
                if (data.status === "success") {
                    $ionicLoading.show({ template: '修改成功.', noBackdrop: true, duration: 1000 });
                    $state.go("login");
                } else {
                    $ionicLoading.show({ template: data.message, noBackdrop: true, duration: 1000 });
                }
            }, $scope.user.phone, validcode, newPassword);
        }
    }
}])

.controller('centerCtrl', ["$scope", "$state","CenterService", function ($scope, $state,centerService) {
    if (localStorage.haslogin != 1) {
        $state.go("login");
    } else {
        
    var userId = localStorage.getItem("userId");
    $scope.account=localStorage.getItem("account");
    $scope.username=localStorage.getItem("username");

        centerService.all(function(data){

            if(data.status==="success")
            {
                $scope.waitConfirm = data.result.waitConfirm;      //待确认
                $scope.sending = data.result.sending;              //配送中
                $scope.finshed = data.result.finshed;              //已完成
            }
        },userId);
    }
    //查询已完成配送的订单
    $scope.history = function () {
        $state.go("tab.history");
    }
    //退出登录
    $scope.exit = function () {
        localStorage.haslogin = 0;
        $state.go("login");
    }
}])

.controller('loginCtrl', ["$scope", "$ionicLoading", "$state", "LoginService", function ($scope, $ionicLoading, $state, loginService) {
    if (!localStorage.getItem("localUser")) {
        loginService.setLocalUser("", "");
    }
    //如果登陆则进入app首页tab-task.html
    if (localStorage.haslogin == 1) {
        $state.go("tab.center");
    }
    // var type = 0;
    var localUser = loginService.getLocalUser();
    $scope.user = {};
    $scope.user.remember = true;
    //判断本地是否记住密码
    if (loginService.isRemeber()) {
        $scope.user.phone = localUser.phone;
        // $scope.user.password = localUser.password;
        $scope.user.remember = localUser.remember;
    }
    //登录
    $scope.login = function () {
        var phone = $scope.user.phone + "";
        var password = $scope.user.password+"";
        var verifyCode = "123456";
        var remember = loginService.isRemeber();
        //加密密码passkey
        // var passKey = 0;
        // //本地记住了密码且加密了则type=1
        // if (remember) {
        //     passKey = (password === localUser.password);
        //     if (passKey)
        //         type = 1;
        //     else
        //         type = 0;
        // } else {
        //     type = 0;
        // }
        $scope.loginLoad = true;
        //验证用户的输入
        if (!phone.length || phone == "undefined" || password == "undefined" || !password.length) {
            $scope.loginLoad = false;
            $ionicLoading.show({ template: '请输入登录手机号码和密码.', noBackdrop: true, duration: 2000 });
        } else if (phone.length != 11) {
            $scope.loginLoad = false;
            $ionicLoading.show({ template: '请输入正确的11位手机号码.', noBackdrop: true, duration: 2000 });
        }
            // else if (!passKey && (password.length > 15 || password.length < 6)) {
        else {
            loginService.login(function (data) {

                if (data.status === "success") {
                    $scope.loginLoad = false;
                    if (data != null && data.result.userid != "") {
                        //用户信息存在本地
                        localStorage.setItem("userId", data.result.userid);
                        localStorage.setItem("account", data.result.account);
                        localStorage.setItem("username", data.result.username);
                        // localStorage.setItem("password", data.result.password);
                        localStorage.setItem("token", data.result.token);
                        
                        //勾选记住密码复选框，保存用户名与密码到本地
                        if ($scope.user.remember) {
                            loginService.setLocalUser(data.result.account, data.result.password);
                        } else {
                            loginService.clearLocalUser();
                        }
                        localStorage.haslogin = 1;
                        console.log($state);
                        $state.go("tab.center");
                    }
                } else {
                    $scope.loginLoad = false;
                    $ionicLoading.show({ template: data.message, noBackdrop: true, duration: 2000 });
                }
            }, phone, password, verifyCode, 1, "123456", "");
        }
    }
}])

.controller('historyCtrl', ["$scope", "HistoryService", "$state", "$ionicPopup", "$ionicLoading", function ($scope, historyService, $state, $ionicPopup, $ionicLoading) {
    if (localStorage.haslogin != 1) {
        $state.go("login");
    }

    var userId = localStorage.getItem("userId");
    //数据未得到
    $scope.historyLoad = false;
    historyService.all(function (data) {
        if (data.status === "success") {
            $scope.historyLoad = true;
            if (data.result.taskList.length > 0 && data != null) {
                $scope.histroyList = data.result.taskList;
                document.getElementById("noTask").style.display = "none";
                document.getElementById("taskContent").style.display = "block";

            } else {
                document.getElementById("noTask").style.display = "block";
                document.getElementById("taskContent").style.display = "none";
            }
        }
    }, userId)
}])

