﻿angular.module('starter.services', [])


//待接单
.factory('WaitListService', function ($resource) {
    return {
        all: function (cb) {
            var waitList = $resource(apiUrl.getWait);
            var token = localStorage.getItem("token");
            waitList.save({}, {
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                }
            }, function (error) {

            });
        },
        //点击抢单
        receive: function (cb,userId, orderNum) {
            var lst = $resource(apiUrl.receive);
            var token = localStorage.getItem("token");
            lst.save({}, {
                ExpressUserId: userId,
                orderNum: orderNum,
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                }
            }, function (error) { });

        }
    }
})


//待确认任务
.factory('TaskService', function ($resource) {
    return {
        all: function (cb, userId) {
            var taskList = $resource(apiUrl.getTaskListByUserId);
            var token = localStorage.getItem("token");
            taskList.save({}, {
                ExpressUserId: userId,
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                    console.log(data);
                }
            }, function (error) {

            });
        },
        //点击确认明细钮后提交数据
        eaitCount: function (cb, userId,orderNum, lstTask) {
            var lst = $resource(apiUrl.getEditBuyCount);
            var token = localStorage.getItem("token");
            lst.save({}, {
                ExpressUserId: userId,
                orderNum: orderNum,
                taskList: lstTask,
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                    console.log(data);
                }
            }, function (error) { });

        }
    }
})

//配送中任务
.factory('DeliveryService', function ($resource) {
    return {
        all: function (cb, userId) {
            var deliveryList = $resource(apiUrl.getSearchSendByUserId);
            var token = localStorage.getItem("token");
            deliveryList.save({}, {
                ExpressUserId: userId,
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                }
            }, function (error) { });
        },
        //点击完成配送按钮后提交数据
        deliveryComplete: function (cb, userId, orderNum) {
            var delComplete = $resource(apiUrl.getFinshedExpressesTask);
            var token = localStorage.getItem("token");
            delComplete.save({}, {
                userId: userId,
                orderNum: orderNum,
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                    console.log(data);
                }
            }, function (error) { });
        }
    }
})

.service('LoginService', function ($resource, $state) {
    return {
        //本地存入用户名、密码
        setLocalUser: function (phone, password) {
            var localUser = {
                phone: phone,
                password: password,
                remember: true
            };
            //保存用户需要序列化
            localStorage.setItem("localUser", JSON.stringify(localUser));
        },
        //获取本地用户名与密码并解析
        getLocalUser: function () {
            if (localStorage.getItem("localUser")) {
                return JSON.parse(localStorage.getItem("localUser"));
            } else {
                localStorage.setItem("localUser", "");
                return null;
            }
        },
        //清除用户
        clearLocalUser: function () {
            localStorage.removeItem("localUser");
        },
        //判断是否记住密码即本地是否存入了用户
        isRemeber: function () {
            var userRemeber = JSON.parse(localStorage.getItem("localUser"));
            if (userRemeber) {
                return true;
            } else {
                return false;
            }
        },

        //传递登录数据信息
        login: function (cb, phone, password, VerifyCode, type, phoneCode, token) {
            var user = $resource(apiUrl.postLogin);
            user.save({}, {
                UserName: phone,
                LoginPassword: md5(password + "zmm&ywq&jxt&bsw&xf&zyj"),
                VerifyCode: VerifyCode,
                Type: type,
                PhoneCode: phoneCode,
                PhoneToken: "phoneToken",
                Token: token
            }, function (data) {
                //回调
                if (cb) {
                    cb(data);
                    console.log(data);
                }
            }, function (error) {
            });
        },
    }
})

.factory('ForgetPwdService', function ($resource) {
    return {
        //获取验证码
        getValidateCode: function (cb, phone) {
            var validateCode = $resource(apiUrl.getSendValidateCode);
            var token = localStorage.getItem("token");
            validateCode.save({}, {
                UserName: phone,
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                    console.log(data);
                }
            }, function (error) { });
        },
        setNewPassword: function (cb, userName, validCode, newPassword) {
            var setNewPwd = $resource(apiUrl.getSetNewPassword);
            var token = localStorage.getItem("token");
            setNewPwd.save({}, {
                userName: userName,
                validCode: validCode,
                newPassword: newPassword,
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                    console.log(data);
                }
            }, function (error) { });
        }
    }
})
    //修改密码
.factory('UpdatePasswordService', function ($resource) {
    return {
        changePassword: function (cb, userName, Password, NewPassword, phoneCode) {
            var updatePwd = $resource(apiUrl.getEditNewPassword);
            var token = localStorage.getItem("token");
            updatePwd.save({}, {
                UserName: userName,
                LoginPassword: md5(Password + "zmm&ywq&jxt&bsw&xf&zyj"),
                NewPassword: md5(NewPassword + "zmm&ywq&jxt&bsw&xf&zyj"),
                PhoneCode: phoneCode,
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                    console.log(data);
                }
            }, function (error) { });
        }
    }
})

//查询配送已完成记录
.factory("HistoryService", function ($resource) {
    return {
        all: function (cb, userId)
        {
            var historyList = $resource(apiUrl.getSearchFinshedByUserId);
            var token = localStorage.getItem("token");
            historyList.save({}, {
                ExpressUserId: userId,
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                }
            }, function (error) {

            });
        }
    }
})

.factory("CenterService",function($resource){

    return{
        all:function(cb,userId){
            var historyList = $resource(apiUrl.getCountByUserId);
            var token = localStorage.getItem("token");
            historyList.save({}, {
                ExpressUserId: userId,
                token: token
            }, function (data) {
                if (cb) {
                    cb(data);
                }
            }, function (error) {
            });
        }
    }
});
